#include <stdio.h>
#include <libxml/parser.h>
#include <libxml/tree.h>
#include <string.h>
#include "level/leveling.h"

int main(int argc,char **argv){

	if(argc!=3){
		printf("usage:adjujda inputfile outputfile\n");
		return -1;
	}
	
	xmlDocPtr doc=NULL;
	xmlNodePtr  cur=NULL;
	char* name=NULL;
	char* value=NULL;

	xmlKeepBlanksDefault(0); 

	doc=xmlParseFile(argv[1]);
	if(doc==NULL){
		fprintf(stderr,"Loading xml file failed.\n");
		return 0; 
	}

	cur=xmlDocGetRootElement(doc);
	if(cur==NULL){
	 	fprintf(stdout,"empty file.\n");
	 	return 0;
	}

	name=BAD_CAST cur->name;
	if(strcmp(name,"gama-local")){
		fprintf(stdout,"file not support\n");
		return 0;
	}
	
	char *nwtype=(char *)xmlGetProp(cur,"network");
	if(!strcmp(nwtype,"leveling")){
		if(leveling(cur,argv[2])){
			//error report
		}
	}

	xmlFree(nwtype);
	xmlFreeDoc(doc);
}
