#include "base.h"
#include <malloc.h>

int ij(int i,int j){
	return (i>=j)?(i*(i+1)/2+j):(j*(j+1)/2+i);
}

int podimat_inversion(double *a, int n){
	double *a0=malloc(sizeof(double)*n);
    	for(int k=0;k<n;k++){ 
		double a00=a[0];
		if(a00+1.0==1.0)
		{
			free(a0); 
			return -1;
		}
		for(int i=1;i<n;i++)
		{
			double ai0 = a[i*(i+1)/2];
			
			if(i<=n-k-1)a0[i]= -ai0/a00;
			else        a0[i]=  ai0/a00;

			for(int j=1;j<=i;j++)
			{
				a[(i-1)*i/2+j-1]=a[i*(i+1)/2+j]+ai0*a0[j];
			} 
		}
		for(int i=1;i<n;i++)
		{
			a[(n-1)*n/2+i-1]=a0[i];
		}
		a[n*(n+1)/2-1]=1.0/a00;
	} 
	free(a0);
	return 0;
	
}
