#ifndef _LEVELING_H_
#define _LEVELING_H_
#include <libxml/parser.h>
#include <libxml/tree.h>

enum leveling_read_xml_return leveling(xmlNodePtr inproot,const char *outputfile);

enum leveling_read_xml_return{
	loadfail=1,
	emptyfile=2,
	withoutdescription=3,
	pointwithoutid=4,
	nopoint=5,
	noobservation=6,
	wnetworktag=7,
	wdescriptiontag=8,
	rootempty=9,
	wknpoint=10,
	getknpointerr=11,
	get0knpoint=12,
	initlnwerr=13,
	pointforerr=14,
	wheightdiff=15,
	obsforerr=16,
	allocatpaerr=17,
	allocatplerr=18,
	inversionerr=19,
	wpointobs=20,
	sucess=0
};

struct level_network{
	//
	double s0;

	//observations
	int obsn;
	int mobsn;
	double *L;
	int *StartP;
	int *EndP;
	double *P;
	double *dist;

	//points
	char **Pname;
	int mpn;
	int known;
	int pointnum;
	double *level;
	
	double *ATPA;
	double *ATPL;
	double *dX;
	double *V;

	double m_pvv;
	double m_mu;

	char *description;
};


#endif
